var MODULE_NAME  = "Generate macro comment";
var MODULE_VER   = "1.0";
var MODULE_TITLE = "Select the commented macro's name";
function Init() {
    menuName = "&" + MODULE_NAME;
    subMenu = "&" + "DMIS";
    addMenuItem(menuName, subMenu, "main", "CTRL+SHIFT+x");
}

// !!! Hello friend !!!
// here you must set the correct path to the 'generator.hta' dialog file ...
// path where the result is written ...
// don't forget to use slash '/' characters instead of backslash '\' ...
// and enjoy !
// vs
var generator = 'D:/ACER-C/wmt7/Tools/dmisinfo/generator.hta'


var xmlFile = 'c:/doc.xml';

var macroname;

function main() 
{
	var	ed = neweditor();
	ed.assignActiveEditor();
	
	macroname = ed.selText();
	if ( macroname.length < 1 )
	{
	   echo( 'Please select the macro name!' );
	   return false;
	}
	
	var text = new String(ed.text());
	var curx = ed.caretX();
	var cury = ed.caretY();
	var pos = indexInText(text, curx, cury); 
	var macHeadY = getMacroHeadPos( text, pos, cury );
	
	// set cursor to the beginning of the macro
	ed.setCaretPos( 0, macHeadY );
	// call the dialog
	if ( !showDialog( macroname ) )
		return false;
	
	// read the generated code
	var commentText = getXmlText( macroname );
	
	//write the text 
	ed.selText(commentText);



}

function getMacroHeadPos( text, pos, cury )
{
	var textAbove = new String();
	textAbove = text.substring(0,pos);
 	var newlineIndex = textAbove.lastIndexOf( "\nMACRO" );
 	var textBtw = new String();
 	textBtw = textAbove.substring( newlineIndex );
 	var reg = new RegExp("\n","g");  
	var linesBtw = textBtw.match( reg );
	var numOfLinesBtw = linesBtw.length;
	return (cury - numOfLinesBtw + 1);
}





function indexInText(text, curx, cury) 
{ //function for lib WSH-PSPad
	// calculate linear coordinate in String text, based on cursor coordinates 
	var i = 1; // from first line, not zero
	var pos = 0;
	var cursymb = new String();
	while (i < cury) 
	{
		pos = text.indexOf("\n",pos);
		pos++;
		i++;
	}
	cursymb = text.charAt(pos);
	if ((cursymb == "\n") || (cursymb == "\r") || (cursymb == "\f")) {
		pos++;
	}
	pos = pos + curx - 1; 

return pos;
}



function showDialog( macroname )
{
   var cmdline = 'mshta.exe ' + generator + ' ' + macroname;

	var WshShell = new ActiveXObject("WScript.Shell");
	var oExec = WshShell.Exec( cmdline );

	while (oExec.Status == 0)
	{
	     sleep(500);
	}
	
	fso = new ActiveXObject("Scripting.FileSystemObject");
	return fso.FileExists(xmlFile);

}



function getXmlText()
{
   var xmlDoc = new ActiveXObject( 'Msxml2.DOMDocument.4.0' );
   xmlDoc.load( xmlFile );
	
	var xmlText = new Array();
	xmlText.push( '<doc macro=\"' + macroname + '\">' );
	for ( var node = 0; node < xmlDoc.documentElement.childNodes.length; node++ )
	{
	   xmlText.push( xmlDoc.documentElement.childNodes[node].xml );
	}
	xmlText.push( '</doc>' );
	
	var commentText = '$$? ';
	var finalText = '\n';
	for ( var node = 0; node < xmlText.length; node++ )
	{
	   var pretext = ( node == 0 || node == xmlText.length -1 ) ? commentText : commentText + '  ';
	   finalText += pretext + xmlText[node] + '\n';
	}
	
	fso = new ActiveXObject("Scripting.FileSystemObject");
	fso.DeleteFile( xmlFile );

	
	return finalText;
}























