var MODULE_NAME  = "Goto next macro head";
var MODULE_VER   = "1.0";
var MODULE_TITLE = "Searches for the next head of the macro";
function Init() {
    menuName = "&" + MODULE_NAME;
    subMenu = "&" + "DMIS";
    addMenuItem(menuName, subMenu, "main", "CTRL+SHIFT+]");
}


function main() 
{
var	ed = neweditor();
ed.assignActiveEditor();
var text = new String(ed.text());
var curx = ed.caretX();
var cury = ed.caretY();
var pos = indexInText(text, curx, cury); //index correction counted in indexInText
var macHeadY = getMacroHeadPos( text, pos, cury );
var nOfLns = getNumOfLines( text );
ed.setCaretPos( 0, nOfLns );
ed.setCaretPos( 0, macHeadY );
}

function getMacroHeadPos( text, pos, cury )
{
	var textBelow = new String();
	textBelow = text.substring(pos);
 	var newlineIndex = textBelow.indexOf( "\nMACRO" );
 	var textBtw = new String();
 	textBtw = textBelow.substring(0, newlineIndex );
 	var reg = new RegExp("\n","g");  
	var linesBtw = textBtw.match( reg );
	var newY;
	if ( linesBtw == null )
		{
		newY = getNumOfLines( text );
		}
	else
 	   {
		newY =  cury + linesBtw.length + 1;
		}

	return (newY);
}


function getNumOfLines( text )
{
   var nOfLns;
   var reg = new RegExp("\n","g");
	var mtch = text.match( reg );
	if ( mtch == null )
	{
 	   nOfLns = 1;
	}
	else
	{
 	   nOfLns = mtch.length;
	}
	return nOfLns;
}


function indexInText(text, curx, cury) 
{ //function for lib WSH-PSPad
	// calculate linear coordinate in String text, based on cursor coordinates 
	var i = 1; // from first line, not zero
	var pos = 0;
	var cursymb = new String();
	while (i < cury) 
	{
		pos = text.indexOf("\n",pos);
		pos++; // next search from next position
		i++;
	}
	cursymb = text.charAt(pos);
	if ((cursymb == "\n") || (cursymb == "\r") || (cursymb == "\f")) {
		pos++;
	}
	pos = pos + curx - 1; // Array index from 0, string index from 1

return pos;
}
